# Documentation

`urql` is a highly customizable and flexible GraphQL client, that
happens to come with some default core behavior and some React
component and hooks APIs.

You can take `urql` from writing your first GraphQL app, to
building a full experience, and all the way to extending it,
making it suitable for your needs, and experimenting with custom
GraphQL clients!

### [Getting Started](getting-started.md)

Let's get up and running! This section explains how to
install `urql` and use its React components and hooks.
This contains everything you need to know to get started
and just use the default `urql`!

### [Architecture](architecture.md)

A quick deep dive into `urql`'s structure, how the
client works, and how requests get sent through the
exchange pipeline to your GraphQL API.

### [Basics](basics.md)

Everything about the basic & default `urql` behavior
that comes with explanations of the `fetchExchange`,
the `cacheExchange`, and how to use _Subscriptions_.

### [Exchanges](exchanges.md)

Here's everything you need to know to customize and augment
every aspect of the GraphQL client from how data is cached
to how components receive their data.

### [Extending & Experimenting](extending-and-experimenting.md)

Here's everything you need to know to extend,
customise and experiment with `urql`. This section
shows you how to use the `Client` to write new
APIs (Be it for React or not) and how to write
new "Exchanges" to customise `urql`'s core behavior!

### [Guides](guides.md)

Here are some guides on how to make common exchanges.

### [API](api.md)
